From b439153a22f78395c117fd222111af7d4d14097a Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Apr 06 2017 23:29:35 +0000
Subject: [PATCH 812/1001] Add an authorization framework


---

diff --git a/hubs/app.py b/hubs/app.py
index c8b5aca..7b28c4c 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -95,11 +95,14 @@ def check_auth():
             )
             flask.session.auth.avatar = username2avatar(
                 flask.session.auth.nickname)
-            flask.session.auth.user = hubs.models.User.by_username(
-                flask.session.auth.nickname)
+
+            user = hubs.models.User.get_or_create(
+                flask.g.db, username=flask.session.auth.nickname,
+                fullname=flask.session.auth.fullname)
+            flask.session.auth.user = user
         flask.g.auth = flask.session.auth
     else:
-        flask.g.auth = munch.Munch(logged_in=False)
+        flask.g.auth = munch.Munch(logged_in=False, user=None)
 
 # Register widgets
 import hubs.widgets  # noqa
diff --git a/hubs/authz.py b/hubs/authz.py
new file mode 100644
index 0000000..ebd85ca
--- /dev/null
+++ b/hubs/authz.py
@@ -0,0 +1,88 @@
+from __future__ import absolute_import, unicode_literals
+
+from enum import IntEnum
+from flask import current_app
+
+
+#class Authorization(object):
+#
+#    def __init__(self, app=None, db=None):
+#        self.db = db
+#        if app is not None:
+#            self.init_app(app)
+#
+#    def init_app(self):
+#        app.config.setdefault("AUTHZ_ADAPTER", None)
+
+
+class AccessLevel(IntEnum):
+    anonymous = 0
+    logged_in = 1
+    member = 2
+    sponsor = 3
+    owner = 4
+
+
+PERMISSIONS = {
+    "hub.public.view": AccessLevel.anonymous,
+    "hub.preview.view": AccessLevel.anonymous,
+    "hub.private.view": AccessLevel.member,
+    "hub.users.manage": AccessLevel.sponsor,
+    "hub.config": AccessLevel.owner,
+    "widget.public.view": AccessLevel.anonymous,
+    "widget.restricted.view": AccessLevel.logged_in,
+}
+
+
+class ObjectAuthzMixin(object):
+
+    def allows(self, user, action):
+        site_admins = current_app.config.get("SITE_ADMINS", [])
+        if user is not None and user.username in site_admins:
+            return True
+        user_level = self._get_auth_access_level(user)
+        permission = self._get_auth_permission_name(action)
+        min_level = PERMISSIONS[permission]
+        if user_level >= min_level:
+            return True
+        return False
+
+    def _get_auth_access_level(self, user):
+        if user is None:
+            return AccessLevel.anonymous
+        levels = [
+            self._get_auth_user_access_level(user),
+            self._get_auth_group_access_level(user),
+        ]
+        return max(l for l in levels if l is not None)
+
+    def _get_auth_user_access_level(self, user):
+        return AccessLevel.logged_in
+
+    def _get_auth_group_access_level(self, user):
+        group = self._get_auth_group()
+        user_roles = self._get_auth_user_roles(user)
+        try:
+            user_level = user_roles[group]
+        except KeyError:
+            # No role for this group
+            return None
+        try:
+            return AccessLevel[user_level]
+        except KeyError:
+            # Unsupported role
+            return None
+
+    def _get_auth_group(self):
+        raise NotImplementedError
+
+    def _get_auth_user_roles(self, user):
+        return get_user_roles(user)
+
+    def _get_auth_permission_name(self, action):
+        return action
+
+
+def get_user_roles(user):
+    # TODO: use the new API
+    return {g: "member" for g in user.groups}
diff --git a/hubs/migrations/versions/bed8bbc0f78e_authz.py b/hubs/migrations/versions/bed8bbc0f78e_authz.py
new file mode 100644
index 0000000..525c2ad
--- /dev/null
+++ b/hubs/migrations/versions/bed8bbc0f78e_authz.py
@@ -0,0 +1,63 @@
+# This Alembic database migration is part of the Fedora Hubs project.
+# Copyright (C) <year>  <name of author>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+"""
+Authorization
+
+Revision ID: bed8bbc0f78e
+Revises: 6d4862ec4f93
+Create Date: 2017-03-30 21:38:03.629462
+"""
+
+from __future__ import absolute_import, unicode_literals
+
+from alembic import op
+import sqlalchemy as sa
+
+
+# revision identifiers, used by Alembic.
+revision = 'bed8bbc0f78e'
+down_revision = '6d4862ec4f93'
+branch_labels = None
+depends_on = None
+
+
+def upgrade():
+    op.add_column(
+        'hubs_config',
+        sa.Column('auth_group', sa.String(length=256), nullable=True))
+    op.add_column(
+        'hubs_config',
+        sa.Column('visibility', sa.Enum('public', 'preview', 'private'),
+                  nullable=True))
+    op.add_column(
+        'widgets',
+        sa.Column('visibility', sa.Enum('public', 'restricted'),
+                  nullable=True))
+    op.execute("UPDATE hubs_config SET visibility = 'public'")
+    op.execute("UPDATE widgets SET visibility = 'public'")
+    with op.batch_alter_table("hubs_config") as batch_op:
+        batch_op.alter_column("visibility", nullable=False)
+    with op.batch_alter_table("widgets") as batch_op:
+        batch_op.alter_column("visibility", nullable=False)
+
+
+def downgrade():
+    # http://alembic.zzzcomputing.com/en/latest/batch.html
+    with op.batch_alter_table("hubs_config") as batch_op:
+        batch_op.drop_column('visibility')
+        batch_op.drop_column('auth_group')
+    with op.batch_alter_table("widgets") as batch_op:
+        batch_op.drop_column('visibility')
diff --git a/hubs/models.py b/hubs/models.py
index 48ed695..758a64f 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -47,6 +47,7 @@ import fedmsg.utils
 
 import hubs.defaults
 import hubs.widgets
+from hubs.authz import ObjectAuthzMixin, AccessLevel
 from hubs.utils import username2avatar
 
 
@@ -135,7 +136,7 @@ class Association(BASE):
             .first()
 
 
-class Hub(BASE):
+class Hub(ObjectAuthzMixin, BASE):
     __tablename__ = 'hubs'
     name = sa.Column(sa.String(50), primary_key=True)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
@@ -221,9 +222,6 @@ class Hub(BASE):
         session.delete(association)
         session.commit()
 
-    def is_admin(self, user):
-        return user in self.owners
-
     @classmethod
     def by_name(cls, name):
         return cls.query.filter_by(name=name).first()
@@ -264,19 +262,39 @@ class Hub(BASE):
         hubs.defaults.add_group_widgets(session, hub, name, summary, **extra)
         return hub
 
-    @property
-    def left_widgets(self):
-        return sorted(
-            [w for w in self.widgets
-             if w.plugin in hubs.widgets.registry and w.left],
-            key=lambda w: w.index)
+    def _get_auth_user_access_level(self, user):
+        # overridden to handle user hubs.
+        if self.user_hub and user.username == self.name:
+            return AccessLevel.owner
+        return super(Hub, self)._get_auth_user_access_level(user)
+
+    def _get_auth_group(self):
+        # While we're local-only, just use the hub name:
+        return self.name
+        # When the CAIAPI is in place we will be able to use the auth_group
+        # setting:
+        # group = self.config.auth_group
+        # if group is None:
+        #     group = self.name
+        # return group
+
+    def _get_auth_user_roles(self, user):
+        """Override until we can get groups from FAS.
+
+        This will not return all roles, only the one for the current hub, but
+        that fine since it's the only one we're interested in when this method
+        is called.
+        """
+        return {
+            assoc.hub.name: assoc.role
+            for assoc in self.associations
+            if assoc.user.username == user.username
+            }
 
-    @property
-    def right_widgets(self):
-        return sorted(
-            [w for w in self.widgets
-             if w.plugin in hubs.widgets.registry and not w.left],
-            key=lambda w: w.index)
+    def _get_auth_permission_name(self, action):
+        if action == "view":
+            action = "{}.view".format(self.config.visibility)
+        return "hub.{}".format(action)
 
     def __json__(self):
         return {
@@ -292,7 +310,11 @@ class Hub(BASE):
 
 
 class HubConfig(BASE):
+
     __tablename__ = 'hubs_config'
+
+    VISIBILITY = ["public", "preview", "private"]
+
     id = sa.Column(sa.Integer, primary_key=True)
     hub_id = sa.Column(sa.String(50), sa.ForeignKey('hubs.name'),
                        nullable=False)
@@ -303,6 +325,9 @@ class HubConfig(BASE):
     header_img = sa.Column(sa.String(256), default=randomheader)
     chat_channel = sa.Column(sa.String(256), nullable=True)
     chat_domain = sa.Column(sa.String(256), nullable=True)
+    auth_group = sa.Column(sa.String(256), nullable=True)
+    visibility = sa.Column(
+        sa.Enum(*VISIBILITY), default="public", nullable=False)
 
     def __json__(self):
         return {
@@ -311,6 +336,7 @@ class HubConfig(BASE):
             'avatar': self.avatar,
             'chat_channel': self.chat_channel,
             'chat_domain': self.chat_domain,
+            'visibility': self.visibility,
         }
 
     @property
@@ -326,8 +352,12 @@ def _widget_config_default(context):
         ]))
 
 
-class Widget(BASE):
+class Widget(ObjectAuthzMixin, BASE):
+
     __tablename__ = 'widgets'
+
+    VISIBILITY = ["public", "restricted"]
+
     idx = sa.Column(sa.Integer, primary_key=True)
     plugin = sa.Column(sa.String(50), nullable=False)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
@@ -336,6 +366,8 @@ class Widget(BASE):
 
     index = sa.Column(sa.Integer, nullable=False)
     left = sa.Column(sa.Boolean, nullable=False, default=False)
+    visibility = sa.Column(
+        sa.Enum(*VISIBILITY), default="public", nullable=False)
 
     @classmethod
     def by_idx(cls, idx):
@@ -359,6 +391,21 @@ class Widget(BASE):
     def config(self, config):
         self._config = json.dumps(config)
 
+    def _get_auth_access_level(self, user):
+        return self.hub._get_auth_access_level(user)
+
+    def _get_auth_user_roles(self, user):
+        """Override until we can get groups from FAS"""
+        return self.hub._get_auth_user_roles(user)
+
+    def _get_auth_permission_name(self, action):
+        if action != "view":
+            return self.hub._get_auth_permission_name(action)
+        hub_visibility = self.hub.config.visibility
+        if hub_visibility != "preview":
+            return "hub.{}.view".format(hub_visibility)
+        return "widget.{}.view".format(self.visibility)
+
     def __json__(self):
         module = hubs.widgets.registry[self.plugin]
         root_view = module.get_views()["root"](module)
diff --git a/hubs/static/client/app/core/HubConfigPanel.jsx b/hubs/static/client/app/core/HubConfigPanel.jsx
index 517042f..ddc22d3 100644
--- a/hubs/static/client/app/core/HubConfigPanel.jsx
+++ b/hubs/static/client/app/core/HubConfigPanel.jsx
@@ -3,6 +3,7 @@ import {
   IntlProvider,
   defineMessages,
   FormattedMessage,
+  FormattedHTMLMessage,
   } from 'react-intl';
 import TabPanel from '../components/TabPanel.jsx';
 
@@ -20,21 +21,51 @@ const messages = defineMessages({
     id: "hubs.core.config.general.summary",
     defaultMessage: "Summary",
   },
+  general_summary_help: {
+    id: "hubs.core.config.general.summary_help",
+    defaultMessage: "This text will be displayed at the top of the hub.",
+  },
   general_left_width: {
     id: "hubs.core.config.general.left_width",
     defaultMessage: "Left width",
   },
+  general_left_width_help: {
+    id: "hubs.core.config.general.left_width_help",
+    defaultMessage: (
+      "Change the proportions of you hub's columns by setting the width of "
+     +"the left column (the right column's width will be {right_width})."
+      ),
+  },
+  general_visibility: {
+    id: "hubs.core.config.general.visibility",
+    defaultMessage: "Visibility",
+  },
+  general_visibility_help: {
+    id: "hubs.core.config.general.visibility_help",
+    defaultMessage: (
+      "Public: the hub is visible to anyone.<br />"
+     +"Private: the hub is only visible to members.<br />"
+     +"Preview: some widgets can be made visible to logged-in users only."
+      ),
+  },
   general_avatar: {
     id: "hubs.core.config.general.avatar",
     defaultMessage: "Avatar",
   },
+  general_avatar_help: {
+    id: "hubs.core.config.general.avatar_help",
+    defaultMessage: "An URL to you hub's main image or logo."
+  },
   chat_title: {
     id: "hubs.core.config.chat.title",
     defaultMessage: "Chat Settings",
   },
   chat_intro_1: {
     id: "hubs.core.config.chat.intro1",
-    defaultMessage: "If your team or project has an IRC channel associated with it, you can connect this hub to it via the Hubs chat widget.",
+    defaultMessage: (
+      "If your team or project has an IRC channel associated with it, you "
+     +"can connect this hub to it via the Hubs chat widget."
+     ),
   },
   chat_intro_2: {
     id: "hubs.core.config.chat.intro2",
@@ -72,6 +103,7 @@ export class GeneralPanel extends React.Component {
 
   render() {
     var stillLoading = (typeof this.props.hubConfig.summary === "undefined");
+    var visibilities = this.props.generalConfig.hub_visibility || [];
     return (
       <div>
         <FormattedMessage {...messages.general_title} tagName="h3" />
@@ -87,6 +119,9 @@ export class GeneralPanel extends React.Component {
             onChange={this.props.handleChange}
             value={this.props.hubConfig.summary || ""}
             />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.general_summary_help} />
+          </p>
         </div>
         <div className="form-group">
           <label htmlFor="hub-settings-general-leftwidth">
@@ -100,6 +135,32 @@ export class GeneralPanel extends React.Component {
             onChange={this.props.handleChange}
             value={this.props.hubConfig.left_width || ""}
             />
+          <p className="form-text text-muted">
+            <FormattedMessage
+              {...messages.general_left_width_help}
+              values={{right_width: 12 - (this.props.hubConfig.left_width || 8)}}
+              />
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-visibility">
+            <FormattedMessage {...messages.general_visibility} />
+          </label>
+          <select
+            className="form-control" name="visibility"
+            value={this.props.hubConfig.visibility || ""}
+            onChange={this.props.handleChange}
+            disabled={stillLoading}
+            >
+            {visibilities.map(function(value) {
+              return (
+                <option value={value} key={value}>{value}</option>
+                );
+            })}
+          </select>
+          <p className="form-text text-muted">
+            <FormattedHTMLMessage {...messages.general_visibility_help} />
+          </p>
         </div>
         <div className="form-group">
           <label htmlFor="hub-settings-general-avatar">
@@ -112,6 +173,9 @@ export class GeneralPanel extends React.Component {
             onChange={this.props.handleChange}
             value={this.props.hubConfig.avatar || ""}
             />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.general_avatar_help} />
+          </p>
         </div>
       </div>
     );
diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index 67d82fa..edd2ba5 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -120,7 +120,7 @@ def auth_set(APP, auth):
         g.auth = auth
         g.oidc_id_token = None
         if not auth:
-            g.auth = munch.Munch(logged_in=False)
+            g.auth = munch.Munch(logged_in=False, user=None)
 
     with appcontext_pushed.connected_to(handler, APP):
         yield
@@ -136,9 +136,7 @@ class FakeUser(object):
         """
         self.username = username
         self.booksmarks = []
-
-    def __getitem__(self, key):
-        return self.dic[key]
+        self.groups = []
 
 
 class FakeAuthorization(object):
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index 2c8f1ff..778ea54 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -66,7 +66,9 @@ class HubsAPITest(hubs.tests.APPTest):
                 result.get_data(as_text=True))
 
     def test_hub_json(self):
-        result = self.app.get('/ralph/json', follow_redirects=True)
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/ralph/json', follow_redirects=True)
         # assert the status code of the response
         self.assertEqual(result.status_code, 200)
         data = {
diff --git a/hubs/tests/test_models.py b/hubs/tests/test_models.py
index 8669160..c3279cd 100644
--- a/hubs/tests/test_models.py
+++ b/hubs/tests/test_models.py
@@ -153,15 +153,3 @@ class ModelTest(hubs.tests.APPTest):
                           session=self.session,
                           username=username,
                           visited_hub=hub)
-
-    def test_removed_widget(self):
-        hub = hubs.models.Hub.get("ralph")
-        widget = hubs.models.Widget(
-            hub=hub, plugin="does-not-exist",
-            left=True, index=-1, _config="{}")
-        self.session.add(widget)
-        self.assertNotIn(
-            "does-not-exist", [w.plugin for w in hub.left_widgets])
-        widget.left = False
-        self.assertNotIn(
-            "does-not-exist", [w.plugin for w in hub.right_widgets])
diff --git a/hubs/tests/test_view_utils.py b/hubs/tests/test_view_utils.py
new file mode 100644
index 0000000..d5e8218
--- /dev/null
+++ b/hubs/tests/test_view_utils.py
@@ -0,0 +1,24 @@
+from __future__ import unicode_literals
+
+import hubs.models
+import hubs.tests
+from hubs.views.utils import get_visible_widgets
+
+
+class ModelTest(hubs.tests.APPTest):
+
+    def test_removed_widget(self):
+        hub = hubs.models.Hub.get("ralph")
+        widget = hubs.models.Widget(
+            hub=hub, plugin="does-not-exist",
+            left=True, index=-1, _config="{}")
+        self.session.add(widget)
+        user = hubs.tests.FakeAuthorization('ralph')
+        with hubs.tests.auth_set(self.app.application, user):
+            with self.app.application.app_context():
+                widgets = get_visible_widgets(hub)
+        self.assertNotIn(
+            "does-not-exist", [w.plugin for w in widgets["left"]])
+        widget.left = False
+        self.assertNotIn(
+            "does-not-exist", [w.plugin for w in widgets["right"]])
diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index d86435f..edab332 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -2,16 +2,19 @@ from __future__ import unicode_literals
 
 import json
 
-import hubs.tests.test_widgets
+from hubs.tests import FakeAuthorization, auth_set
+from hubs.tests.test_widgets import WidgetTest
 
 
-class TestBadges(hubs.tests.test_widgets.WidgetTest):
+class TestAbout(WidgetTest):
     plugin = 'about'  # The name in hubs.widgets.registry
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json' % widget.idx)
-        assert response.status_code == 200, response.status_code
+        user = FakeAuthorization('ralph')
+        with auth_set(self.app.application, user):
+            response = self.app.get('/ralph/%i/json' % widget.idx)
+        self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data['data'], {
             'text': 'Testing.',
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index 3521ec2..30284fd 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -2,16 +2,20 @@ from __future__ import unicode_literals
 
 import json
 
-import hubs.tests.test_widgets
+import hubs.widgets
+from hubs.tests import FakeAuthorization, auth_set
+from hubs.tests.test_widgets import WidgetTest
 
 
-class TestBadges(hubs.tests.test_widgets.WidgetTest):
+class TestBadges(WidgetTest):
     plugin = 'badges'  # The name in hubs.widgets.registry
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json' % widget.idx)
-        assert response.status_code == 200, response.status_code
+        user = FakeAuthorization('ralph')
+        with auth_set(self.app.application, user):
+            response = self.app.get('/ralph/%i/json' % widget.idx)
+        self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertEquals(data['plugin'], 'badges')
         self.assertIn('assertions', data['data'].keys())
diff --git a/hubs/tests/test_widgets/test_contact.py b/hubs/tests/test_widgets/test_contact.py
index a934c38..3e63953 100644
--- a/hubs/tests/test_widgets/test_contact.py
+++ b/hubs/tests/test_widgets/test_contact.py
@@ -73,7 +73,9 @@ class ContactsTest(APPTest):
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json' % widget.idx)
+        user = FakeAuthorization('ralph')
+        with auth_set(self.app.application, user):
+            response = self.app.get('/ralph/%i/json' % widget.idx)
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data['data'], {
diff --git a/hubs/tests/test_widgets/test_fedmsgstats.py b/hubs/tests/test_widgets/test_fedmsgstats.py
index cb3d5d3..4861b49 100644
--- a/hubs/tests/test_widgets/test_fedmsgstats.py
+++ b/hubs/tests/test_widgets/test_fedmsgstats.py
@@ -2,16 +2,19 @@ from __future__ import unicode_literals
 
 import json
 
-import hubs.tests.test_widgets
+from hubs.tests import FakeAuthorization, auth_set
+from hubs.tests.test_widgets import WidgetTest
 
 
-class TestFedmsgStats(hubs.tests.test_widgets.WidgetTest):
+class TestFedmsgStats(WidgetTest):
     plugin = 'fedmsgstats'  # The name in hubs.widgets.registry
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json' % widget.idx)
-        assert response.status_code == 200, response.status_code
+        user = FakeAuthorization('ralph')
+        with auth_set(self.app.application, user):
+            response = self.app.get('/ralph/%i/json' % widget.idx)
+        self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data['data'], {
             u'fedmsgs': 83854,
diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index 0e09a7d..eaac331 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -2,16 +2,18 @@ from __future__ import unicode_literals
 
 import json
 
-import hubs.tests.test_widgets
-import hubs.models
+from hubs.tests import FakeAuthorization, auth_set
+from hubs.tests.test_widgets import WidgetTest
 
 
-class TestLibrary(hubs.tests.test_widgets.WidgetTest):
+class TestLibrary(WidgetTest):
     plugin = 'library'  # The name in hubs.widgets.registry
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json' % widget.idx)
+        user = FakeAuthorization('ralph')
+        with auth_set(self.app.application, user):
+            response = self.app.get('/ralph/%i/json' % widget.idx)
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         expected_dict = {
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 78c41b9..8c2784b 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -2,16 +2,19 @@ from __future__ import unicode_literals
 
 import json
 
-import hubs.tests.test_widgets
+from hubs.tests import FakeAuthorization, auth_set
+from hubs.tests.test_widgets import WidgetTest
 
 
-class TestMeetings(hubs.tests.test_widgets.WidgetTest):
+class TestMeetings(WidgetTest):
     plugin = 'meetings'
 
     def test_data_simple(self):
         team = 'i18n'
         widget = self.widget_instance(team, self.plugin)
-        response = self.app.get('/%s/%i/json' % (team, widget.idx))
+        user = FakeAuthorization('ralph')
+        with auth_set(self.app.application, user):
+            response = self.app.get('/%s/%i/json' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
         data = json.loads(response.get_data(as_text=True))
         calendar_name = data['data']['calendar']
@@ -20,8 +23,10 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
     def test_render_simple(self):
         team = 'i18n'
         widget = self.widget_instance(team, self.plugin)
-        response = self.app.get('/%s/w/%s/%i/'
-                                % (team, self.plugin, widget.idx))
+        user = FakeAuthorization('ralph')
+        with auth_set(self.app.application, user):
+            response = self.app.get('/%s/w/%s/%i/'
+                                    % (team, self.plugin, widget.idx))
         self.assertEqual(200, response.status_code)
         self.assertIn('i18n', response.get_data(as_text=True))
         self.assertIn('<strong>Request A New Meeting</strong>',
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 4227357..75b5764 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -5,19 +5,25 @@ import flask
 import hubs.models
 
 from hubs.app import app
-from .utils import get_hub, login_required, RequestValidator
+from .utils import (
+    get_hub, get_visible_widgets, login_required, RequestValidator,
+    require_hub_access,
+    )
 
 
 @app.route('/<name>')
 @app.route('/<name>/')
+@require_hub_access("view")
 def hub(name):
     hub = get_hub(name, load_config=True)
+    widgets = get_visible_widgets(hub)
     return flask.render_template(
-        'hubs.html', hub=hub, edit=False)
+        'hubs.html', hub=hub, widgets=widgets, edit=False)
 
 
 @app.route('/<name>/json/')
 @app.route('/<name>/json')
+@require_hub_access("view", json=True)
 def hub_json(name):
     hub = get_hub(name)
     response = flask.jsonify(hub.__json__())
@@ -27,21 +33,22 @@ def hub_json(name):
 
 @app.route('/<name>/edit', methods=['GET', 'POST'])
 @login_required
+@require_hub_access("config")
 def hub_edit(name):
+    hub = get_hub(name, load_config=True)
     if flask.request.method == 'POST':
-        return hub_edit_post(name)
+        return hub_edit_post(hub)
     else:
-        return hub_edit_get(name)
+        return hub_edit_get(hub)
 
 
-def hub_edit_get(name):
-    hub = get_hub(name, load_config=True)
+def hub_edit_get(hub):
+    widgets = get_visible_widgets(hub)
     return flask.render_template(
-        'hubs.html', hub=hub, edit=True)
+        'hubs.html', hub=hub, widgets=widgets, edit=True)
 
 
-def hub_edit_post(name):
-    hub = get_hub(name)
+def hub_edit_post(hub):
     is_js = flask.request.form.get('js', False)
 
     error = False
@@ -138,11 +145,12 @@ def hub_edit_post(name):
         else:
             return ('ok', 200)
     else:
-        return flask.redirect(flask.url_for('hub', name=name))
+        return flask.redirect(flask.url_for('hub', name=hub.name))
 
 
 @app.route('/<name>/config', methods=['GET', 'POST'])
 @login_required
+@require_hub_access("config", json=True)
 def hub_config(name):
     hub = get_hub(name)
     config = {
@@ -151,6 +159,7 @@ def hub_config(name):
             "hub": {},
             "general": {
                 "chat_networks": app.config["CHAT_NETWORKS"],
+                "hub_visibility": hubs.models.HubConfig.VISIBILITY,
             },
         },
     }
diff --git a/hubs/views/root.py b/hubs/views/root.py
index 1250490..74215da 100644
--- a/hubs/views/root.py
+++ b/hubs/views/root.py
@@ -48,9 +48,6 @@ def login():
     else:
         return_point = default
 
-    hubs.models.User.get_or_create(
-        flask.g.db, username=flask.g.auth.nickname,
-        fullname=flask.g.auth.fullname)
     flask.flash('Login successful', 'success')
 
     return flask.redirect(return_point)
diff --git a/hubs/views/user.py b/hubs/views/user.py
index 62866ae..5012aea 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -6,14 +6,18 @@ import hubs.models
 import hubs.stream
 
 from hubs.app import app
-from .utils import login_required, get_hub
+from .utils import (
+    login_required, get_hub, get_visible_widgets, require_hub_access,
+    )
 
 
 @app.route('/<name>/stream')
 @app.route('/<name>/stream/')
 @login_required
+@require_hub_access("view")
 def stream(name):
     hub = get_hub(name)
+    widgets = get_visible_widgets(hub)
     saved = hubs.models.SavedNotification.by_username(name)
     saved = [n.__json__() for n in saved]
 
@@ -23,6 +27,7 @@ def stream(name):
     return flask.render_template(
         'stream.html',
         hub=hub,
+        widgets=widgets,
         saved=json.dumps(saved),
         actions=actions
     )
